3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used. You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example: git-rebase master~1 topic
26 A---B---C topic A'\''--B'\''--C'\'' topic
28 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
38 When you have resolved this problem run \"git rebase --continue\".
39 If you would prefer to skip this patch, instead run \"git rebase --skip\".
40 To restore the original branch and stop rebasing run \"git rebase --abort\".
45 dotest
=$GIT_DIR/.dotest-merge
51 test -n "$prev_head" || die
"prev_head must be defined"
52 test -d "$dotest" || die
"$dotest directory does not exist"
54 unmerged
=$
(git ls-files
-u)
55 if test -n "$unmerged"
57 echo "You still have unmerged paths in your index"
58 echo "did you forget to use git add?"
62 cmt
=`cat $dotest/current`
63 if ! git diff-index
--quiet HEAD
65 if ! git-commit
-C "$cmt"
67 echo "Commit failed, please do not call \"git commit\""
68 echo "directly, but instead do one of the following: "
71 printf "Committed: %0${prec}d " $msgnum
73 printf "Already applied: %0${prec}d " $msgnum
75 git rev-list
--pretty=oneline
-1 "$cmt" |
sed -e 's/^[^ ]* //'
77 prev_head
=`git rev-parse HEAD^0`
78 # save the resulting commit so we can read-tree on it later
79 echo "$prev_head" > "$dotest/prev_head"
81 # onto the next patch:
82 msgnum
=$
(($msgnum + 1))
83 echo "$msgnum" >"$dotest/msgnum"
87 cmt
="$(cat $dotest/cmt.$1)"
88 echo "$cmt" > "$dotest/current"
89 hd
=$
(git rev-parse
--verify HEAD
)
90 cmt_name
=$
(git symbolic-ref HEAD
)
91 msgnum
=$
(cat $dotest/msgnum
)
92 end
=$
(cat $dotest/end
)
93 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
94 eval GITHEAD_
$hd='"$(cat $dotest/onto_name)"'
95 export GITHEAD_
$cmt GITHEAD_
$hd
96 git-merge-
$strategy "$cmt^" -- "$hd" "$cmt"
100 unset GITHEAD_
$cmt GITHEAD_
$hd
108 echo "Strategy: $rv $strategy failed, try another" 1>&2
112 die
"Unknown exit code ($rv) from command:" \
113 "git-merge-$strategy $cmt^ -- HEAD $cmt"
124 test -f "$dotest"/interactive ||
125 while :; do case $#,"$1" in 0,|
*,-i|
*,--interactive) break ;; esac
130 is_interactive
"$@" && exec git-rebase--interactive
"$@"
136 git diff-files
--quiet ||
{
137 echo "You must edit all merge conflicts and then"
138 echo "mark them as resolved using git add"
143 prev_head
="`cat $dotest/prev_head`"
144 end
="`cat $dotest/end`"
145 msgnum
="`cat $dotest/msgnum`"
146 onto
="`cat $dotest/onto`"
148 while test "$msgnum" -le "$end"
156 git am
--resolved --3way --resolvemsg="$RESOLVEMSG"
163 prev_head
="`cat $dotest/prev_head`"
164 end
="`cat $dotest/end`"
165 msgnum
="`cat $dotest/msgnum`"
166 msgnum
=$
(($msgnum + 1))
167 onto
="`cat $dotest/onto`"
168 while test "$msgnum" -le "$end"
176 git am
-3 --skip --resolvemsg="$RESOLVEMSG"
188 die
"No rebase in progress?"
190 git
reset --hard ORIG_HEAD
194 test 2 -le "$#" || usage
198 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
201 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
202 --strateg=*|
--strategy=*|\
203 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
206 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
219 git_am_opt
="$git_am_opt $1"
222 git_am_opt
="$git_am_opt $1"
234 # Make sure we do not have .dotest
235 if test -z "$do_merge"
242 It seems that I cannot create a .dotest directory, and I wonder if you
243 are in the middle of patch application or another rebase. If that is not
244 the case, please rm -fr .dotest and run me again. I am stopping in case
245 you still have something valuable there.'
251 die
"previous dotest directory $dotest still exists." \
252 'try git-rebase < --continue | --abort >'
256 # The tree must be really really clean.
257 git update-index
--refresh ||
exit
258 diff=$
(git diff-index
--cached --name-status -r HEAD
)
260 ?
*) echo "cannot rebase: your index is not up-to-date"
266 # The upstream head must be given. Make sure it is valid.
268 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
269 die
"invalid upstream $upstream_name"
271 # Make sure the branch to rebase onto is valid.
272 onto_name
=${newbase-"$upstream_name"}
273 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
275 # If a hook exists, give it a chance to interrupt
276 if test -x "$GIT_DIR/hooks/pre-rebase"
278 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
{
279 echo >&2 "The pre-rebase hook refused to rebase."
284 # If the branch to rebase is given, first switch to it.
288 git-checkout
"$2" || usage
291 if branch_name
=`git symbolic-ref -q HEAD`
293 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
295 branch_name
=HEAD
;# detached
299 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
301 # Now we are rebasing commits $upstream..$branch on top of $onto
303 # Check if we are already based on $onto with linear history,
304 # but this should be done only when upstream and onto are the same.
305 mb
=$
(git merge-base
"$onto" "$branch")
306 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
308 ! git rev-list
--parents "$onto"..
"$branch" |
grep " .* " > /dev
/null
310 echo >&2 "Current branch $branch_name is up to date."
314 if test -n "$verbose"
316 echo "Changes from $mb to $onto:"
317 # We want color (if set), but no pager
318 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
321 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
322 echo "First, rewinding head to replay your work on top of it..."
323 git-reset
--hard "$onto"
325 # If the $onto is a proper descendant of the tip of the branch, then
326 # we just fast forwarded.
327 if test "$mb" = "$branch"
329 echo >&2 "Fast-forwarded $branch_name to $onto_name."
333 if test -z "$do_merge"
335 git format-patch
-k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
336 git am
$git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
340 # start doing a rebase with git-merge
341 # this is rename-aware if the recursive (default) strategy is used
344 echo "$onto" > "$dotest/onto"
345 echo "$onto_name" > "$dotest/onto_name"
346 prev_head
=`git rev-parse HEAD^0`
347 echo "$prev_head" > "$dotest/prev_head"
350 for cmt
in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
352 msgnum
=$
(($msgnum + 1))
353 echo "$cmt" > "$dotest/cmt.$msgnum"
356 echo 1 >"$dotest/msgnum"
357 echo $msgnum >"$dotest/end"
362 while test "$msgnum" -le "$end"